%define aurox_ver 9.3
%define rel 1

%define gclver 2.6.1
%define gclprever 23
%define version %{gclver}

#define ansi 1

# WARNING: Rebuilding on Fedora Core 1 or Aurox 9.3 requires disabling exec-shield
# echo 0 > /proc/sys/kernel/exec-shield

Summary: GNU Common Lisp
Name:	 gcl
Epoch:	 0
Version: %{version}
Release: %{aurox_ver}.aur.%{?gclprever:0.%{gclprever}.}%{rel}
License: LGPL
Group:	 Development/Languages
URL:	 http://savannah.gnu.org/projects/gcl/
#Source: ftp://ftp.gnu.org/gnu/gcl/gcl-2.5.3.tar.gz
Source:  ftp://ftp.debian.org/debian/pool/main/g/gcl/gcl_%{gclver}-%{gclprever}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

# use optflags 
Patch1: gcl-2.6.1-optflags.patch
# fix --enable-emacsdir configure option
# http://savannah.gnu.org/bugs/?func=detailbug&bug_id=6561&group_id=879
#Patch2: gcl-2.6.1-emacsdir.patch
Patch3: gcl-2.6.1-unixport.patch

BuildRequires: readline-devel ncurses-devel
BuildRequires: tetex texinfo
BuildRequires: gmp-devel
BuildRequires: tcl-devel tk-devel XFree86-devel
# BuildRequires: emacs

Requires(post,preun): /sbin/install-info
## gcc not strictly required: needed only to compile, but not run, lisp programs
Requires: gcc
## Let rpm pick these up automatically
# Requires: gmp ncurses readline 
# Requires: tcl tk
## We install stuff in /usr/share/emacs/site-lisp, so we Require its owner,  No, for now.  -- Rex
#Requires: emacs = %(rpm -q emacs --qf '%%{version}')

%description
GCL is a Common Lisp currently compliant with the CLtL1 standard. Lisp
compilation produces native code through the intermediary of the system's C
compiler, from which GCL derives efficient performance and facile
portability. Currently uses TCL/Tk as GUI.


%prep
%setup -q

%patch1 -p1 -b .optflags
%patch3 -p1 -b .sedfix


%build
#  --enable-vssize=65536*2 --enable-statsysbfd --enable-maxpage=128*1024 

CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing -Wa,--execstack" \
%configure \
  --enable-notify=no \
  --enable-dynsysgmp \
  --enable-readline \
  --enable-emacsdir=%{_datadir}/emacs/site-lisp \
  --enable-infodir=%{_infodir} \
  --enable-tkconfig=%{_libdir} \
  --enable-tclconfig=%{_libdir} \
  %{?ansi:--enable-ansi} \
  %{?configure_opts}

make -C gmp3 %{?_smp_mflags}
# NOT smp safe
make 

%{?ansi:make -C ansi-tests test-unixport }


%install
rm -rf $RPM_BUILD_ROOT

make install DESTDIR=$RPM_BUILD_ROOT

install -m644 -D -p man/man1/gcl.1 $RPM_BUILD_ROOT%{_mandir}/man1/gcl.1

# Fix perms
find $RPM_BUILD_ROOT%{_datadir}/emacs -type f -name "*.el" -exec chmod a-x {} ';'

# Unwanted/unpackaged files
rm -f  $RPM_BUILD_ROOT%{_infodir}/dir
rm -rf $RPM_BUILD_ROOT%{_libdir}/gcl-%{version}/info
rm -rf $RPM_BUILD_ROOT%{_datadir}/doc


%post
/sbin/install-info %{_infodir}/gcl.info.gz %{_infodir}/dir ||:
/sbin/install-info %{_infodir}/gcl-si.info.gz %{_infodir}/dir ||:
/sbin/install-info %{_infodir}/gcl-tk.info.gz %{_infodir}/dir ||:

%preun
if [ $1 -eq 0 ]; then
  /sbin/install-info --delete %{_infodir}/gcl.info.gz %{_infodir}/dir ||:
  /sbin/install-info --delete %{_infodir}/gcl-si.info.gz %{_infodir}/dir ||:
  /sbin/install-info --delete %{_infodir}/gcl-tk.info.gz %{_infodir}/dir ||:
fi


%files
%defattr(-,root,root,-)
%doc readme faq ChangeLog 
%{_bindir}/gcl
%{_infodir}/gcl*.info*
%{_mandir}/man1/gcl.1*
%dir %{_libdir}/gcl-%{version}
%{_libdir}/gcl-%{version}/[a-f,h-z]*
# tk/tcl stuff (subpkg?)
%{_libdir}/gcl-%{version}/gcl-tk 
# emacs stuff (subpkg?)
%dir %{_datadir}/emacs
%dir %{_datadir}/emacs/site-lisp
%{_datadir}/emacs/site-lisp/*
%exclude %{_datadir}/emacs/site-lisp/default.el

%clean
rm -rf $RPM_BUILD_ROOT


%changelog
* Sat Feb 07 2004 Aurox Team <aurox@aurox.org> 0:2.6.1-9.3.aur.0.23.1
- new snapshot
- exclude default.el file (conflict with emacs package

* Fri Nov 14 2003 Rex Dieter <rexdieter at sf.net> 0:2.6.1-0.fdr.1
- 2.6.1: fixes tk interface.
- make easy to enable ansi support (future).

* Thu Nov 13 2003 Rex Dieter <rexdieter at sf.net> 0:2.5.3-0.fdr.4
- fix detection/use of tk/tcl on rh9
- tk interface still non-fucntional: bug submitted upstream:
  http://savannah.gnu.org/bugs/?func=detailbug&bug_id=6534&group_id=879
- no longer explicitly (Build)Requires: emacs
- use version-agnostic %%_datadir/emacs/site-lisp

* Wed Nov 12 2003 Rex Dieter <rexdieter at sf.net> 0:2.5.3-0.fdr.3
- remove explict Requires for gmp, ncurses, readline

* Sun Oct 05 2003 Rex Dieter <rexdieter at sf.net> 0:2.5.3-0.fdr.2
- update macros for Fedora Core support
- (Build)Requires: emacs
- BuildRequires: texinfo, XFree86-devel
- fix perms on install emacs files
- remove redundant Requires
- remove extraneous cvs tags
- make pre/post scriptlet failures non-fatal.

* Fri Sep 19 2003 Rex Dieter <rexdieter at sf.net> 0:2.5.3-0.fdr.1
- Requires: gcc

* Tue Sep 16 2003 Rex Dieter <rexdieter at sf.net> 0:2.5.3-0.fdr.0
- first try 

